/*AIS 2017*/
/*based off of the android sdk example skeleton code*/

package com.ais.reflectiontest;

import android.app.PendingIntent;
import android.content.Context;
import android.os.IBinder;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.widget.TextView;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

public class MainActivity extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        TextView tv = (TextView) findViewById(R.id.textbox);


        tv.setText(SMSApi() ? "Message sent!" : "Exception during internal API Call.");
    }

    public boolean SMSApi() {
        Context context = getApplicationContext();
        String phoneNumber = "5551234";
        String message = "Message from the internal API";


        try {
            Method m = Class.forName("android.os.ServiceManager").getDeclaredMethod("getService", String.class);
            Object ismsService = m.invoke(null, "isms");

            m = Class.forName("com.android.internal.telephony.ISms$Stub").getDeclaredMethod("asInterface", IBinder.class);
            m.setAccessible(true);

            Object stubObj = m.invoke(null, ismsService);
            Class stubClass = stubObj.getClass();

            try {

                m = stubClass.getMethod("sendText", String.class, String.class, String.class, PendingIntent.class, PendingIntent.class);
                m.invoke(stubObj, phoneNumber, null, message, null, null);
            } catch (NoSuchMethodException e) {
                try {
                    m = stubClass.getMethod("sendText", String.class, String.class, String.class, String.class, PendingIntent.class, PendingIntent.class);
                    m.invoke(stubObj, context.getPackageName(), phoneNumber, null, message, null, null);
                } catch (NoSuchMethodException e2) {
                    m = stubClass.getMethod("getPreferredSmsSubscription");
                    int subId = (int) m.invoke(stubObj);

                    m = stubClass.getMethod("sendTextForSubscriber", int.class, String.class, String.class, String.class, String.class, PendingIntent.class, PendingIntent.class, boolean.class);
                    m.invoke(stubObj, subId, context.getPackageName(), phoneNumber, null, message, null, null, true);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
            return false;
        }
        return true;
    }
}



